
#include "fann.h"

//#define DATAFILE      "xor.data"
//#define NETFILE       "xor_float.net""
#define DATAFILE      "data/rtstact.data"
#define NETFILE       "data/rtstact.net"

#include "floatfann.h"

int main()
{
    const unsigned int num_input = 2;
    const unsigned int num_output = 1;
    const unsigned int num_layers = 3;
    const unsigned int num_neurons_hidden = 3;
    const float desired_error = (const float) 0.001;
    const unsigned int max_epochs = 100000;
    const unsigned int epochs_between_reports = 1000;

    struct fann *ann = fann_create_standard(num_layers, num_input, num_neurons_hidden, num_output);

    fann_set_activation_function_hidden(ann, FANN_SIGMOID_SYMMETRIC);
    fann_set_activation_function_output(ann, FANN_SIGMOID_SYMMETRIC);

    fann_train_on_file(ann, DATAFILE, max_epochs, epochs_between_reports, desired_error);

    fann_save(ann, NETFILE);

    fann_destroy(ann);

    return 0;
}

