
#ifndef SIMSTATS_H_
#define SIMSTATS_H_

#include <sys/time.h>
#include <time.h>

class SimStats 
{
  int num_simulations;   
  int num_players;
  
  int * remaining_units; 
  int * remaining_ttlhp; 
  int * wins;
  
  struct timeval tv_start, tv_end;
     
public:
  SimStats();
  virtual ~SimStats();     
  
  int get_numplayers() { return num_players; }
  void inc_num() { num_simulations++; }
  void inc_win(int player) { wins[player]++; }
  
  void set_numplayers(int n); 
  
  void add_stats(SimStats & stats);   
  
  void add_remaining_units(int player, int num);
  void add_remaining_ttlhp(int player, int num);
  
  void start_timer(); 
  void stop_timer(); 
  
  void print(); 
};

#endif

