
#include <stdlib.h>
#include <time.h>

#include <map>
#include <string> 
#include <sstream>

#include "Features.H"
#include "GameObj.H"
#include "MiniGameState.H" 
#include "Player.H"
#include "TacticalGreedyNNPlayer.H"
#include "Worker.H" 

using namespace std;

static bool debug = true; 

TacticalGreedyNNPlayer::TacticalGreedyNNPlayer(int num)
  : DefaultPlayer(num)
{
  name = "TacticalGreedyNNPlayer";
  
  //ann = fann_create_from_file("data/rtstact.net");    
        
  enabledFtrs.push_back(FTR_HPDIFF);
  enabledFtrs.push_back(FTR_UNITCOSTDIFF);
  
  timestep = 0; 
  
}

TacticalGreedyNNPlayer::~TacticalGreedyNNPlayer()
{
  if (ann != NULL) fann_destroy(ann);  
}

void TacticalGreedyNNPlayer::calc_features()
{
  ftrVals.clear(); 
  Features::snapshot(*statePtr, enabledFtrs, ftrVals);  
}

/*  
  FORALL (snapshots, ss)
{
    cout << "."; 
    fflush(stdout); 
        
    outfile << (*ss) << endl;
    outfile << winner << endl;
        
    if (calc_error)
{
      vector<string> parts;
      boost::split(parts, (*ss), boost::is_any_of(" ")); 
          
      fann_type *calc_out;
      fann_type input[2];
    
      input[0] = to_double(parts[0]);
      input[1] = to_double(parts[1]);
      calc_out = fann_run(ann, input);
    
          //printf("xor test (%f,%f) -> %f\n", input[0], input[1], calc_out[0]);
      double error = ABS(winner - calc_out[0]);
      cout << "inputs " << input[0] << " " << input[1] << " -> " << calc_out[0]
          << ", err = " << error << endl;     
}
}
*/         

void TacticalGreedyNNPlayer::pre_objloop()
{
  calc_features();  
  
  my_units.clear(); 
  opp_units.clear(); 
  
  DPR << "Adding all objs to lists " << timestep << endl; 
  
  FORALL(statePtr->all_objs, iter)
  {
    GameObj<MiniGameState>* obj = *iter; 
    
    if (obj->owner == 0) 
      my_units.push_back(obj); 
    else
      opp_units.push_back(obj);
  }  
  
  // each obj can: 
  //   move towards nearest enemy         1
  //   move away from nearest enemy       2
  //   move orthogonally both directions  3,4
  //   stay                               5
  //
  // let's encode joint actions as strings. 
  
  
  
  
  timestep++; 
}

string TacticalGreedyNNPlayer::chooseAction(int objId, Marine* marinePtr, MiniGameState& state)
{  
  return "";
}


