
#ifndef TACTICALGREEDYNNPLAYER_H
#define TACTICALGREEDYNNPLAYER_H

#include <vector>
#include <map>
#include <string>

#include "MiniGameState.H"
#include "Player.H"

#include "floatfann.h"

class TacticalGreedyNNPlayer : public DefaultPlayer
{  
  struct fann *ann;   
  std::vector<int> enabledFtrs; 
  std::vector<double> ftrVals;  
  std::vector<GameObj<MiniGameState>*> my_units; 
  std::vector<GameObj<MiniGameState>*> opp_units;
  
  std::map<std::string, double> actionValues; 
  
  int timestep; 
  
protected:
  // Called individually in big loop  
  virtual std::string chooseAction(int objId, Marine* marinePtr, MiniGameState& state);
  void calc_features();     
  
  virtual void pre_objloop(); 
      
public:
  TacticalGreedyNNPlayer(int num); 
  virtual ~TacticalGreedyNNPlayer(); 
    
};

#endif

