#!/bin/sh

PNAME=$0
URLPREFIX="http://www.cs.ualberta.ca/~lanctot/ortslite"
HOMEDIR="."
TMPDIR="/tmp/ortslite"

installfann() 
{
  PKG="fann-2.1.0beta.zip"
  echo "$PNAME: Installing $PKG"
  cd $TMPDIR
  wget "$URLPREFIX/$PKG" || return 1
  unzip $PKG
  cd fann-2.1.0
  ./configure --prefix=$HOMEDIR && make && make install || return 1
  echo ""
}

die()
{
  echo "$1"
  exit 1
}

echo "This script installs external libs in your home directory: "
echo "   fann 2.1.0beta (Fast Artificial Neural Network) "
echo ""
echo "Please enter your home directory: "
read homedir

mkdir -p $TMPDIR || die "Could not create tmp dir $TMPDIR"

echo "Home directory is $homedir"

HOMEDIR=$homedir

installfann || die "Failed to install FANN"

echo ""
echo "External libs successfully installed. "
echo "Note 1: package contents left in $TMPDIR"
echo "Note 2: You may have to add $HOMEDIR/lib to your LD_LIBRARY_PATH environment variable"


