#!/usr/local/bin/perl

use warnings; 
use strict;

my $FILEPREF="data/eplog";

sub parse_log
{
  my $epnum = shift; 
  my $log = shift; 

  open(OUT, ">$FILEPREF.$epnum") || die "Could not open file for writing\n";

  print OUT "$log\n";

  close(OUT); 

  # already handled in ortslite
  #my @parts = split("@", $log);

  #my $seed = $parts[0]; 
  #my $parms = $parts[1]; 
  #my $init = $parts[2];
  #my $firstmove = $parts[3];
  #my $secondmove = $parts[4];

  #print "seed = $seed\nparms = $parms\ninit = $init\nfirstmove = $firstmove\nsecondmove = $secondmove\n"
}

### main prog

my $file = $ARGV[0]; 

if (!$file) 
{
  print "Usage: parse_rlclog.pl <file>\n";
  print "\n";
  exit;
}

open(FILE, "<$file") || die "Can't open input file"; 

my $line = ""; 

my $num = 10; 
my $i = 0; 

while($line = <FILE>)
{
  chomp($line); 

  if ($line =~ m/^EpisodeNumber:([0-9]+) Return:(.*) Steps:([0-9]+)/)
  {    
    my $epnum = $1; 
    my $return = $2; 
    my $steps = $3; 
    #print "Found episode # $epnum ret=$return steps=$steps\n";
    #print "$line\n"; 
  }
  elsif ($line =~ m/^EpisodeNumber:([0-9]+) theLog:(.*)$/)
  { 
    $i++; 
    my $epnum = $1; 
    my $log = $2; 

    if ($i >= $num) {
      last; 
    }

    #print "Found log episode # $epnum log = $log\n";

    print "Parsing episode $epnum ... "; 
    
    parse_log($epnum, $log); 

    print "written to $FILEPREF.$epnum\n";
  }

}

